Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::BlitSquare Class Reference

STK band-limited square wave class. More...

`#include <BlitSquare.h>`

Inheritance diagram for stk::BlitSquare:

## Public Member Functions
| BlitSquare (StkFloat frequency=220.0)
| Default constructor that initializes BLIT frequency to 220 Hz.
| ~BlitSquare ()
| Class destructor.
void | reset ()
| Resets the oscillator state and phase to 0.
void | setPhase (StkFloat phase)
| Set the phase of the signal. More...
StkFloat | getPhase () const
| Get the current phase of the signal. More...
void | setFrequency (StkFloat frequency)
| Set the impulse train rate in terms of a frequency in Hz.
void | setHarmonics (unsigned int nHarmonics=0)
| Set the number of harmonics generated in the signal. More...
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs. More...
Public Member Functions inherited from stk::Generator
| Generator (void)
| Class constructor.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK band-limited square wave class.

This class generates a band-limited square wave signal. It is derived in part from the approach reported by Stilson and Smith in "Alias-Free Digital Synthesis of Classic Analog Waveforms", 1996. The algorithm implemented in this class uses a SincM function with an even M value to achieve a bipolar bandlimited impulse train. This signal is then integrated to achieve a square waveform. The integration process has an associated DC offset so a DC blocking filter is applied at the output.

The user can specify both the fundamental frequency of the waveform and the number of harmonics contained in the resulting signal.

If nHarmonics is 0, then the signal will contain all harmonics up to half the sample rate. Note, however, that this setting may produce aliasing in the signal when the frequency is changing (no automatic modification of the number of harmonics is performed by the setFrequency() function). Also note that the harmonics of a square wave fall at odd integer multiples of the fundamental, so aliasing will happen with a lower fundamental than with the other Blit waveforms. This class is not guaranteed to be well behaved in the presence of significant aliasing.

Based on initial code of Robin Davies, 2005. Modified algorithm code by Gary Scavone, 2005 - 2006.

## Member Function Documentation

void stk::BlitSquare::setPhase | ( | StkFloat | phase | ) |
| inline

Set the phase of the signal.

Set the phase of the signal, in the range 0 to 1.

58 { phase_ = PI * phase; };

StkFloat stk::BlitSquare::getPhase | ( |  | ) | const
| inline

Get the current phase of the signal.

Get the phase of the signal, in the range [0 to 1.0).

64 { return phase_ / PI; };

void stk::BlitSquare::setHarmonics | ( | unsigned int | nHarmonics = `0` | ) |

Set the number of harmonics generated in the signal.

This function sets the number of harmonics contained in the resulting signal. It is equivalent to (2 * M) + 1 in the BLIT algorithm. The default value of 0 sets the algorithm for maximum harmonic content (harmonics up to half the sample rate). This parameter is not checked against the current sample rate and fundamental frequency. Thus, aliasing can result if one or more harmonics for a given fundamental frequency exceeds fs / 2. This behavior was chosen over the potentially more problematic solution of automatically modifying the M parameter, which can produce audible clicks in the signal.

StkFrames & stk::BlitSquare::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inline virtual

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

152 {
153 #if defined(_STK_DEBUG_)
154 if ( channel >= frames.channels() ) {
155 oStream_ << "BlitSquare::tick(): channel and StkFrames arguments are incompatible!";
156 handleError( StkError::FUNCTION_ARGUMENT );
157 }
158 #endif
159
160 StkFloat *samples = &frames[channel];
161 unsigned int hop = frames.channels();
162 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
163 *samples = BlitSquare::tick();
164
165 return frames;
166 }

The documentation for this class was generated from the following file:

- BlitSquare.h

The Synthesis ToolKit in C++ (STK)
©1995--2017 Perry R. Cook and Gary P. Scavone. All Rights Reserved.